(*.tests for rationals
   Stefan Karnel
   2002
   use"../kbtest/rational.sml";
   use"kbtest/rational.sml";
   use"rational.sml";
.*)


(*. tests of internal functions: to make them work, 
    out-comment (*!!!*) in knowledge/Rational.ML:
(*!!!
structure RationalI : RATIONALI =
struct
!!!*)

(*!!!
end;(*struct*)
open RationalI;
!!!*)

print("\n\n*********************   rational.sml - TESTS    *************************\n\n");
print("\n\n***** divide tests *****\n");
val mv_pquot1 = (#1(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[0,0,1]),(1,[0,0,0])] *)
if mv_pquot1=[(1,[0,0,1]),(1,[0,0,0])] then () else raise error ("rational.sml: example failed");

val mv_prest1 = (#2(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[1,0,1]),(~1,[0,0,1])] *)
if mv_prest1=[(1,[1,0,1]),(~1,[0,0,1])] then () else raise error ("rational.sml: example failed");

val mv_pquot2 = (#1(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_)));
(* result: [(4,[1]),(4,[0])] *)
if mv_pquot2=[(4,[1]),(4,[0])] then () else raise error ("rational.sml: example failed");

val mv_prest2 = (#2(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_)));
(* result: [(12,[0]] *)
if mv_prest2=[(12,[0])] then () else raise error ("rational.sml: example failed");

val mv_pquot3 = (#1(mv_division([(4,[2]),(~4,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(2,[1]),(~2,[0])] *)
if mv_pquot3=[(2,[1]),(~2,[0])] then () else raise error ("rational.sml: example failed");

val mv_prest3 = (#2(mv_division([(1,[2]),(~1,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(1,[2]),(~1,[0])] *)
if mv_prest3=[(1,[2]),(~1,[0])] then () else raise error ("rational.sml: example failed");

val mv_pquot4 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],LEX_)));
(* [(1,[0,1,1])] *)
if mv_pquot4=[(1,[0,1,1])] then () else raise error ("rational.sml: example failed");

val mv_prest4 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],GGO_)));
(* [(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] *)
if mv_prest4 =[(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] then () else raise error ("rational.sml: example failed");

val mv_pquot5 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_)));
(* [(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])]*)
if mv_pquot5=[(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])] then () else raise error ("rational.sml: example failed");

val mv_prest5 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_)));
(* [] *)
if mv_prest5=[] then () else raise error ("rational.sml: example failed");

(* (x^2 + 2(a+1)x + (a^2+2a+1)) / (x+a+1) = x+a+1 *)
val mv_pquot6 = (#1(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_pquot6=[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])] then () else raise error ("rational.sml: example failed");

val mv_prest6 = (#2(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_prest6=[] then () else raise error ("rational.sml: example failed");


print("\n\n***** MV_CONTENT-TESTS *****\n");
val mv_cont1=mv_content([(1,[2,1]),(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]);
(* [(1,[0,1]),(1,[0,0])] *)
if  mv_cont1=[(1,[0,1]),(1,[0,0])] then () else raise error ("rational.sml: example failed");

val mv_pp1=mv_pp([(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]);
(*[(1,[1,0]),(1,[0,0])]*)
if mv_pp1=[(1,[1,0]),(1,[0,0])] then () else raise error ("rational.sml: example failed");

val mv_cont2=mv_content([(2,[1]),(4,[0])]);
(* [(2,[0])] *)
if mv_cont2=[(2,[0])] then () else raise error ("rational.sml: example failed");

val mv_pp2=mv_pp([(2,[1]),(4,[0])]);
(* [(1,[1]),(2,[0])] *)
if mv_pp2=[(1,[1]),(2,[0])] then () else raise error ("rational.sml: example failed");

val mv_cont3=mv_content[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(2,[0,0,0])] *)
if mv_cont3=[(2,[0,0,0])] then () else raise error ("rational.sml: example failed");

val mv_pp3=mv_pp[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] *)
if mv_pp3=[(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] then () else raise error ("rational.sml: example failed");

val mv_cont4=mv_content[(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(1,[0,0,0])] *)
if mv_cont4=[(1,[0,0,0])] then () else raise error ("rational.sml: example failed");

val mv_pp4=mv_pp [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] *)
if mv_pp4=[(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] then () else raise error ("rational.sml: example failed");

val con1=mv_content([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[0,0])] *)
if con1=[(3,[0,0])] then () else raise error ("rational.sml: example failed");

val pp1=mv_pp([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] *)
if pp1=[(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] then () else raise error ("rational.sml: example failed");

val con2=mv_content([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]);
(* [(1,[0,0])] *)
if con2=[(1,[0,0])] then () else raise error ("rational.sml: example failed");

val pp2 =mv_pp([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]);
(* [(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] *)
if pp2=[(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] then () else raise error ("rational.sml: example failed");

val cont1 = mv_content [(1,[2,1,0]),(2,[2,1,0])];
(* [(3,[0,1,0])] *)
if cont1=[(3,[0,1,0])] then () else raise error ("rational.sml: example failed");

val pp1 = mv_pp [(1,[2,1,0]),(2,[2,1,0])];
(* [(1,[2,0,0])] *)
if pp1=[(1,[2,0,0])] then () else raise error ("rational.sml: example failed");

val cont2 = mv_content [(4,[1,2,0]),(2,[2,1,0])];
(* [(2,[0,1,0])] *)
if cont2=[(2,[0,1,0])] then () else raise error ("rational.sml: example failed");

val pp2 = mv_pp [(4,[1,2,0]),(2,[2,1,0])];
(* [(1,[2,0,0]),(2,[1,1,0])] *)
if pp2=[(1,[2,0,0]),(2,[1,1,0])] then () else raise error ("rational.sml: example failed");

print("\n\n\n\n********************************************************\n\n");
val cont3=mv_content [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];
if cont3=[(5,[0,2,1]),(4,[0,2,0]),(2,[0,1,1])] then () else raise error ("rational.sml: example failed");
val pp3=mv_pp [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];

---------------------------------------------------------------------------*)

fun parse_rat str = (term_of o the o (parse thy)) str;

print("\n\n***** mv_gcd-tests *****\n");
val ggt1 = mv_gcd [(4,[2,2]),(8,[1,1]),(4,[0,0])] [(2,[1,1]),(2,[0,0])];
(* [(2,[1,1]),(2,[0,0])] *)
if ggt1=[(2,[1,1]),(2,[0,0])] then () else raise error ("rational.sml: example failed");

val ggt2 = mv_gcd [(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(15,[1,1,1])] [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(2,[1,1,0]),(3,[0,0,1])] *)
if ggt2=[(2,[1,1,0]),(3,[0,0,1])] then () else raise error ("rational.sml: example failed");


val ggt3 = mv_gcd [(1,[2,0]),(~2,[1,1]),(1,[0,2])] [(1,[1,0]),(~1,[0,1])];
(* [(1,[1,0]),(~1,[0,1])] *)
if ggt3=[(1,[1,0]),(~1,[0,1])] then () else raise error ("rational.sml: example failed");


val ggt4 = mv_gcd [(1,[2,1,0]),(2,[2,1,0])] [(5,[1,0,0])];
(* [(1,[1,0,0])] *)
if ggt4=[(1,[1,0,0])] then () else raise error ("rational.sml: example failed");


val ggt5 = mv_gcd [(4,[2,0]),(~8,[1,1]),(4,[0,2])] [(1,[2,0]),(~1,[0,2])];
(* [(1,[1,0]),(~1,[0,1])] *)
if ggt5=[(1,[1,0]),(~1,[0,1])] then () else raise error ("rational.sml: example failed");


val ggt6 = mv_gcd [(10,[2,1,1]),(14,[1,1,0]),(3,[1,0,1]),(20,[1,2,1])] [(5,[1,1,1]),(7,[2,1,1])];
(* [(1,[0,0,0])] *)
if ggt6=[(1,[1,0,0])] then () else raise error ("rational.sml: example failed");

print("\n\n***** kgv-tests *****\n");
val kgv1=mv_lcm [(10,[])] [(15,[])];
(* [(30,[])] *)
if kgv1=[(30,[])] then () else raise error ("rational.sml: example failed");

val kgv2=mv_lcm [(1,[2,0]),(~2,[1,1]),(1,[0,2])] [(1,[1,0]),(~1,[0,1])];
(* [(1,[2,0]),(~2,[1,1]),(1,[0,2])] *)
if kgv2=[(1,[2,0]),(~2,[1,1]),(1,[0,2])] then () else raise error ("rational.sml: example failed");

val kgv3=mv_lcm [(4,[2,0]),(~8,[1,1]),(4,[0,2])] [(1,[2,0]),(~1,[0,2])];
(* [(4,[3,0]),(~4,[2,1]),(~4,[1,2]),(4,[0,3])] *)
if kgv3=[(4,[3,0]),(~4,[2,1]),(~4,[1,2]),(4,[0,3])] then () else raise error ("rational.sml: example failed");

(*!!!--------
print("\n\n***** STEP_CANCEL_TESTS: *****\n");

val term2 = (term_of o the o (parse thy)) " (9 * a^^^2 * b) /  (6 * a * c)";
val div2 = term2str (step_cancel term2);
if div2 =  "3 * (a * b) * (3 * a) / (2 * c * (3 * a))" then () else raise error ("rational.sml: example failed");


val term1 = (term_of o the o (parse thy)) "(10 * a^^^2 * b * c + 14 * a * b + 3 * a * c + 20 * a * b^^^2 * c) / a";
val div1  = term2str(step_cancel term1);
if div1 =  "(3 * c + 14 * b + 20 * (b ^^^ 2 * c) + 10 * (a * (b * c))) * a / (1 * a)" then () else raise error ("rational.sml: example failed");

val term3 = (term_of o the o (parse thy)) "(10 * a^^^2 * b * c) / (1 * x * y * z) ";
val div3 = term2str(step_cancel term3);
if div3="10 * a ^^^ 2 * b * c / (1 * x * y * z)" then () else  raise error ("rational.sml: example failed");

--------------------------------------------------------------------------!!!*)

(*-----versuche 13.3.03-----
 val t = str2term "1 - x^^^2 - 5 * x^^^5";
 val vs=(((map free2str) o vars) t);
 val Some ml = expanded2poly t vs;
 poly2term (ml, vs);
 poly2term'(rev(sort (mv_geq LEX_) (ml)),vs);
 poly2term'([(~5,[5]),(~1,[2]),(1,[0])], vs);
 monom2term((~5,[5]),vs);
 monom2term((~1,[2]),vs);
 val t' = monom2term((1,[0]),vs);(*uncaught exception LIST*)

 val (i,is) = (~1,[2]);
 val ttt = Const ("op *", [HOLogic.realT,HOLogic.realT]---> HOLogic.realT) $
		   (Const ("uminus", HOLogic.realT --> HOLogic.realT) $
		   Free ((str_of_int o abs) i, HOLogic.realT)) $
		   powerproduct2term(is, vs);
 term2str ttt;
-------versuche 13.3.03-----*)

 val t = str2term "1 - x^^^2 - 5 * x^^^5";
 val Some t' = expanded2polynomial t; term2str t';
"1 + - 1 * x ^^^ 2 + - 5 * x ^^^ 5";
 val t = str2term "1 - x";
 val Some t' = expanded2polynomial t; term2str t';
"1 + - 1 * x";
 val t = str2term "1 + (-1) * x";
 val Some t' = expanded2polynomial t; term2str t';
"1 + - 1 * x";
 val t = (term_of o the o (parse thy)) "1 + (-1) * x ^^^ 2 + (-5) * x ^^^5";
 val Some t' = polynomial2expanded t; term2str t';
"1 - x ^^^ 2 - 5 * x ^^^ 5";


" external calculating functions test ";
" external calculating functions test ";
" external calculating functions test ";

val t1 = (term_of o the o (parse thy)) "((3 * x^^^2 + 6 *x + 3) / (2*x + 2))";
val Some (t1',asm)= factout_p_ thy t1;
term2str t1'; terms2str asm;
"(3 + 3 * x) * (1 + 1 * x) / (2 * (1 + 1 * x))";
"[]";
val Some (t1',asm)= cancel_p_ thy t1;
term2str t1'; terms2str asm;
"(3 + 3 * x) / 2";
"[\"1 + 1 * x ~= 0\"]";

val t = (term_of o the o (parse thy)) "((-3 * x^^^2 + 6 *x - 3) / (2*x - 2))";
val Some (t',asm)= cancel_ thy t; 
term2str t'; terms2str asm;
"(3 - 3 * x) / 2";
"[\"-1 + x ~= 0\"]";
val Some (t',asm)= factout_ thy t;
term2str t'; terms2str asm;
"(3 - 3 * x) * (-1 + x) / (2 * (-1 + x))";
"[]";

val t = str2term "((x+ (-1)) / (x + 1)) + ((x + 1) / (x + (-1)))";
val Some (t',asm) = add_fraction_p_ thy t;
term2str t'; terms2str asm;
"(2 + 2 * x ^^^ 2) / (-1 + 1 * x ^^^ 2)";
"[]";
val Some (t',asm) = common_nominator_p_ thy t; 
term2str t'; terms2str asm;
"(-1 + 1 * x) * (-1 + 1 * x) / ((1 + 1 * x) * (-1 + 1 * x)) +\n(1 + 1 * x) * (1 + 1 * x) / ((1 + 1 * x) * (-1 + 1 * x))";
"[]";

val t = str2term "((x - 1) / (x + 1)) + ((x + 1) / (x - 1))";
val Some (t',asm) = add_fraction_ thy t;
term2str t'; terms2str asm;
"(2 + 2 * x ^^^ 2) / (-1 + x ^^^ 2)";
"[]";
val Some (t',asm) = common_nominator_ thy t; 
term2str t'; terms2str asm;
"(-1 + x) * (-1 + x) / ((1 + x) * (-1 + x)) +\n(1 + x) * (1 + x) / ((1 + x) * (-1 + x))";
"[]";

val t = str2term "((1) / (2*x + 2)) + ((1) / (2*x + (-2))) + ((1) / ( x^^^2 + (-1)))+((1) / (x^^^2 + (-2)*x + 1))";
val Some (t',asm) = common_nominator_p_ thy t; 
term2str t'; terms2str asm;
"1 * (1 + -2 * x + 1 * x ^^^ 2) /\n((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n(1 * (-1 + 1 * x ^^^ 2) /\n ((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n (1 * (-2 + 2 * x) / ((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n  1 * (#";                
"[]";
val Some (t',asm) = add_fraction_p_ thy t; 
term2str t'; terms2str asm;
"1 * x / (1 + -2 * x + 1 * x ^^^ 2)";
"[\"1 + 1 * x ~= 0\"]";
val Some(t',asm) = norm_rational_ thy t;
term2str t'; terms2str asm;
"1 * x / (1 + -2 * x + 1 * x ^^^ 2)";
"[\"1 + 1 * x ~= 0\"]";

val t3 = (term_of o the o (parse thy)) "((1) / (2*x + 2)) + ((1) / (2*x - 2)) + ((1) / ( x^^^2 - 1))+((1) / (x^^^2 - 2 * x + 1))";
val Some (t3',_) = common_nominator_ thy t3; 
val Some (t3'',_) = add_fraction_ thy t3; 
(term2str t3'); 
(term2str t3''); 

val Some(t4,t5) = norm_expanded_rat_ thy t3;
term2str t4;
term2str (hd(t5));



  val t=(term_of o the o (parse thy)) "(9 - x^^^2)/(9 - 6*x + x^^^2)";
  val Some (t',_) = factout_ thy t;
  val Some (t'',_) = cancel_ thy t;
  term2str t';
  term2str t'';
  "(3 + x) * (3 - x) / ((3 - x) * (3 - x))";
  "(3 + x) / (3 - x)";
  			   
  val t=(term_of o the o (parse thy))
	    "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1 / (3 - x)";
  val Some (t',_) = common_nominator_ thy t;
  val Some (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "(9 - x ^^^ 2) / ((3 - x) * (3 - x)) + 1 * (3 - x) / ((3 - x) * (3 - x))";
  "(4 + x) / (3 - x)";

  (*WN.16.10.02 hinzugef"ugt -----vv---*)
  val t=(term_of o the o (parse thy))
	    "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1";
  val Some (t',_) = common_nominator_ thy t;
  val Some (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\
  \1 * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
  "6 / (3 - x)";

  val t=(term_of o the o (parse thy))
	    "1 + (9 - x^^^2) / (9 - 6*x + x^^^2)";
  val Some (t',_) = common_nominator_ thy t;
  val Some (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "1 * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\
  \(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
  "6 / (3 - x)";
  (*WN.16.10.02 hinzugef"ugt -----^^---*)

  val t=(term_of o the o (parse thy)) 
  	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2)";
  val Some (t',_) = factout_ thy t;
  val Some (t'',_) = cancel_ thy t;
  term2str t';
  term2str t'';
  "(y + x) * (y - x) / ((y - x) * (y - x))";
  "(y + x) / (y - x)";
    
  val t=(term_of o the o (parse thy)) 
	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2) + 1 / (y - x)";
  val Some (t',_) = common_nominator_ thy t;
  val Some (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "((-1) * x ^^^ 2 + y ^^^ 2) / (((-1) * x + y) * ((-1) * x + y)) +\
  \1 * ((-1) * x + y) / (((-1) * x + y) * ((-1) * x + y))";
  "((-1) - x - y) / (x - y)";
  (*WN.16.10.02     ^^^^^^^ Reihenfolge aus Angabe umgekehrt ?!*)

  val t=(term_of o the o (parse thy)) 
	    "(x^^^2 - y^^^2)/(x^^^2 - 2*x*y + y^^^2) + 1 / (x - y)";
  val Some (t',_) = common_nominator_ thy t;
  val Some (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "((-1) * y ^^^ 2 + x ^^^ 2) / (((-1) * y + x) * ((-1) * y + x)) +\
  \1 * ((-1) * y + x) / (((-1) * y + x) * ((-1) * y + x))";
  "((-1) - y - x) / (y - x)";
  (*WN.16.10.02     ^^^^^^^ lexicographische Ordnung ?!*)

  val t=(term_of o the o (parse thy)) 
  	    "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2)";
  val Some (t',_) = norm_expanded_rat_ thy t;
  term2str t';
  "(y + x) / (y - x)";
(*val Some (t'',_) = norm_rational_ thy t;
  term2str t'';
  *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial 
  WN.16.10.02 ?!*)
 
  val t=(term_of o the o (parse thy)) 
	    "(9 - x^^^2)/(9 - 6*x + x^^^2) + (1)/(3 + x)";
  val Some (t',_) = norm_expanded_rat_ thy t;
  term2str t';
  "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)";
(*val Some (t'',_) = norm_rational_ thy t;
  term2str t'';
  *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial
  WN.16.10.02 ?!*)
 
  val t=(term_of o the o (parse thy)) 
	    "(9 + (-1)* x^^^2)/(9 + (-1)* 6*x + x^^^2) + (1)/(3 + x)";
  val Some (t',_) = norm_expanded_rat_ thy t;
  val Some (t'',_) = norm_rational_ thy t;
  term2str t';
  term2str t'';
  "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)";
  "(12 + 5 * x + x ^^^ 2) / (9 + (-1) * x ^^^ 2)";


" examples from: Mathematik 1 Schalk Reniets Verlag ";
" examples from: Mathematik 1 Schalk Reniets Verlag ";
" examples from: Mathematik 1 Schalk Reniets Verlag ";


"------------------ cancel -----------------------";
"------------------ cancel -----------------------";
"------------------ cancel -----------------------";
val thy' = "Rational.thy";
val rls' = "cancel";
val mp = "make_polynomial";

print("\n\nexample 186:\n");
print("a)\n");
val e186a'="(14 * x * y) / ( x * y )";
val e186a = the (rewrite_set thy' false "cancel" e186a');
  is_expanded (parse_rat "14 * x * y");
  is_expanded (parse_rat "x * y");

print("b)\n");
val e186b'="(60 * a * b) / ( 15 * a  * b )";
val e186b = the (rewrite_set thy' false "cancel" e186b');
print("c)\n");
val e186c'="(144 * a^^^2 * b * c) / (12 * a * b * c )";
val e186c = (the (rewrite_set thy' false "cancel" e186c'))
    handle e => print_exn e;
val t = (term_of o the o (parse thy)) e186c';
atomt t;

print("\n\nexample 187:\n");
print("a)\n");
val e187a'="(12 * x * y) / (8 * y^^^2 )";
val e187a = the (rewrite_set thy' false "cancel" e187a');
print("b)\n");
val e187b'="(8 * x^^^2 * y * z ) / (18 * x * y^^^2 * z )";
val e187b = the (rewrite_set thy' false "cancel" e187b');
print("c)\n");
val e187c'="(9 * x^^^5 * y^^^2 * z^^^4) / (15 * x^^^6 * y^^^3 * z )";
val e187c = the (rewrite_set thy' false "cancel" e187c');

"example 188:";
val e188a'="(-8 + 8 * x) / (-9 + 9 * x)";
val e188a = the (rewrite_set thy' false "cancel" e188a');
  is_expanded (parse_rat "8 * x + -8");
(* e188a = ("8 / 9",["not ((-1) + x = 0)"]) then () 13.3.03*)
if e188a = ("8 / 9",["-1 + x ~= 0"]) then ()
else raise error "rationals.sml: e188a new behaviour";
val Some (t,_) = rewrite_set thy' false mp 
			     "(8*((-1) + x))/(9*((-1) + x))";
print("b)\n");
val e188b'="(-15 + 5 * x) / (-18 + 6 * x)";
val Some (t,_) = rewrite_set thy' false "cancel" e188b';
print("c)\n");
(*WN.23.10.02-------
val e188c'="( a + -1 * b ) / ( b + -1 * a )";
val e188c = the (rewrite_set thy' false "cancel" e188c');
  is_expanded (parse_rat "a + -1 * b");
  false; -----------!!!*)
val Some (t,_) = 
    rewrite_set thy' false mp "((-1)*(b + (-1) * a))/(1*(b + (-1) * a))";
if t= "(-1 * b + a) / (b + -1 * a)"  then()
else raise error "rationals.sml: e188c new behaviour";

print("\n\nexample 190:\n");
print("c)\n");
val e190c'="( 27 * a^^^3 + 9 * a^^^2 + 3 * a + 1 ) / ( 27 * a^^^3 + 18 * a^^^2 + 3 * a )";
val e190c = the (rewrite_set thy' false "cancel" e190c');
val Some (t,_) = rewrite_set thy' false mp "((1 + 9 * a ^^^ 2)*(1 + 3 * a))/((3 * a + 9 * a ^^^ 2)*(1 + 3 * a))";
(* t="(1 + (3 * a + (27 * a ^^^ 3 + 9 * a ^^^ 2))) /\n(3 * a + (18 * a ^^^ 2 + 27 * a ^^^ 3))"then()
  WN:TERMORDER            ~~~~~~~       ~~~~~~~ f"ur Matthias Goldgruber*)
if t = "(1 + 3 * a + 9 * a ^^^ 2 + 27 * a ^^^ 3) /\n(3 * a + 18 * a ^^^ 2 + 27 * a ^^^ 3)" then ()
else raise error "rationals.sml: e190c new behaviour";

print("\n\nexample 191:\n");
print("a)\n");
val e191a'="( x^^^2 + -1 * y^^^2 ) / ( x + y )";
(*WN.23.10.02-------
val e191a = the (rewrite_set thy' false "cancel" e191a'); 
  is_expanded (parse_rat "x^^^2 + -1 * y^^^2");
  false;
  is_expanded (parse_rat "x + y");
  true; -----------*)
val Some (t,_) = rewrite_set thy' false mp "((x + (-1) * y)*(x + y))/((1)*(x + y))";
(* t="(x ^^^ 2 + -1 * y ^^^ 2) / (x + y)" then() WN.13.3.03*)
if t="(x ^^^ 2 + -1 * y ^^^ 2) / (x + y)" then()
else raise error "rationals.sml: e191a new behaviour";

print("c)\n");
val e191c'="( 9 * x^^^2 + -30 * x + 25 ) / ( 9 * x^^^2 + -25 )";
(*WN.23.10.02-------
val e191c = the (rewrite_set thy' false "cancel" e191c');
  is_expanded (parse_rat "9 * x^^^2 + -30 * x + 25");
  false;
  is_expanded (parse_rat "25 + -30*x + 9*x^^^2");
  false;
  is_expanded (parse_rat "-25 + 9*x^^^2");
  true;------------*)
val Some (t,_) = rewrite_set thy' false mp "(((-5) + 3 * x)*((-5) + 3 * x))/((5 + 3 * x)*((-5) + 3 * x))";
(* t="(25 + ((-30) * x + 9 * x ^^^ 2)) / ((-25) + 9 * x ^^^ 2)"then() 13.3.03*)
if t= "(25 + -30 * x + 9 * x ^^^ 2) / (-25 + 9 * x ^^^ 2)" then()
else raise error "rationals.sml: 'e191c' new behaviour";


print("\n\nexample 192:\n");
print("b)\n");
val e192b'="( 7 * x^^^3 + -1 * x^^^2 * y ) / ( 7 * x * y^^^2 + -1 *  y^^^3 )";
(*WN.23.10.02-------
val e192b = the (rewrite_set thy' false "cancel" e192b');
-------------------*)
val Some (t,_) = rewrite_set thy' false mp "((x ^^^ 2)*(7 * x + (-1) * y))/((y ^^^ 2)*(7 * x + (-1) * y))";
(* t="(7 * x ^^^ 3 + -1 * (y * x ^^^ 2)) / (-1 * y ^^^ 3 + 7 * (x * y ^^^ 2))"then()
  TERMORDER                ~~~~~  f"ur Matthias Goldgruber*)
if t = "(-1 * y * x ^^^ 2 + 7 * x ^^^ 3) / (-1 * y ^^^ 3 + 7 * x * y ^^^ 2)"
then () else raise error "rationals.sml: 'e192b' new behaviour";

print("\n\nexample 193:\n");
print("a)\n");
val e193a'="( x^^^2 + -6 * x + 9 ) / ( x^^^2 + -9 )";
(*WN.23.10.02-------
val e193a = the (rewrite_set thy' false "cancel" e193a');
-------------------*)
print("b)\n");
val e193b'="( x^^^2 + -8 * x + 16 ) / ( 2 * x^^^2 + -32 )";
(*WN.23.10.02-------
val e193b = the (rewrite_set thy' false "cancel" e193b');
print("c)\n");
val e193c'="( 2 * x + -50 * x^^^3 ) / ( 25 * x^^^2 + -10 * x + 1 )";
val Some(t,_) = rewrite_set thy' false "cancel" e193c';
-------------------*)

val wn01 = "(-25 + 9*x^^^2)/(5 + 3*x)";
val Some (t,_) = rewrite_set thy' false "cancel" wn01;
(* t = "((-5) + 3 * x) / 1" then () WN.13.3.03*)
if t = "(-5 + 3 * x) / 1" then ()
else raise error "rational.sml: new behav. in cancel wn01";


"------------------ common_nominator_p -----------------------";
"------------------ common_nominator_p -----------------------";
"------------------ common_nominator_p -----------------------";
val rls' = "common_nominator_p";

print("\n\nexample 204:\n");
print("a)\n");
val e204a'="((5 * x) / 9) + ((3 * x) / 9) + (x / 9)";
val e204a = the (rewrite_set thy' false "common_nominator_p" e204a');
print("b)\n");
val e204b'="5 / x + -3 / x + -1 / x";
val e204b = the (rewrite_set thy' false "common_nominator_p" e204b');

print("\n\nexample 205:\n");
print("a)\n");
val e205a'="((4 * x + 7) / 8) + ((4 * x + 3) / 8)";
val e205a = the (rewrite_set thy' false "common_nominator_p" e205a');
print("b)\n");
val e205b'="((5 * x + 2) / 3) + ((-2 * x + 1) / 3)";
val e205b = the (rewrite_set thy' false "common_nominator_p" e205b');

print("\n\nexample 206:\n");
print("a)\n");
val e206a'="((5 * x + 4) / (2 * x + -1)) + ((9 * x + 5) / (2 * x + -1))";
val e206a = the (rewrite_set thy' false "common_nominator_p" e206a'); 
print("b)\n");
val e206b'="((17 * x + -23) / (5 * x + 4)) + ((-25 + -17 * x) / (5 * x + 4))";
val e206b = the (rewrite_set thy' false "common_nominator_p" e206b');

print("\n\nexample 207:\n");
val e207'="((3 * x * y + 3 * y) / (x * y)) + ((5 * x * y + 7 * y) / (x * y)) + ((9 * x * y + -2 * y) / (x * y)) + ((x * y + 4 * y) / (x * y)) ";
val e207 = the (rewrite_set thy' false "common_nominator_p" e207'); 

print("\n\nexample 208:\n");
val e208'="((3 * x + 2) / (x + 2)) + ((5 * x + -1) / (x + 2)) + ((-7 * x + -3) / (x + 2)) + ((-1 * x + -3) / (x + 2)) ";
val e208 = the (rewrite_set thy' false "common_nominator_p" e208'); 

print("\n\nexample 209:\n");
val e209'="((3 * x + -7 * y + 3 * z) / (4)) + ((2 * x + 17 * y + 10 * z) / (4)) + ((-1 * x + 2 * y + z) / (4)) ";
val e209 = the (rewrite_set thy' false "common_nominator_p" e209'); 

print("\n\nexample 210:\n");
val e210'="((2 * x + 3 +  -1 * x^^^2) / (5 * x)) + ((5 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-3 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-1 * x^^^2 + -3 * x + -5) / (5 * x)) ";
val e210 = the (rewrite_set thy' false "common_nominator_p" e210'); 

print("\n\nexample 211:\n");
print("a)\n"); 
val e211a'="((b) / (a + -1 * b)) + ((-1 * a) / (a + -1 * b))"; 
val e211a = the (rewrite_set thy' false "common_nominator_p" e211a'); 
print("b)\n");
val e211b'="((b) / (b^^^2 + -1 * a^^^2)) + ((-1 * a) / (b^^^2 + -1 * a^^^2))";
val e211b = the (rewrite_set thy' false "common_nominator_p" e211b');

print("\n\nexample 212:\n");
print("a)\n");
val e212a'="((4) / (x)) + ((-3) / (y)) + -1";
val e212a = the (rewrite_set thy' false "common_nominator_p" e212a'); 
print("b)\n");
val e212b'="((4) / (x)) + ((-5) / (y)) + ((6) / (x*y))";
val e212b = the (rewrite_set thy' false "common_nominator_p" e212b');

print("\n\nexample 213:\n");
print("a)\n"); 
val e213a'="((5 * x) / (3 * y^^^2)) + ((19 * z) / (6 * x * y)) +  ((-2 * x) / (3 * y^^^2)) + ((7 * y^^^2) / (6 * x^^^2)) ";
val e213a = the (rewrite_set thy' false "common_nominator_p" e213a'); 
print("b)\n"); 
val e213b'="((2 * b) / (3 * a^^^2)) + ((3 * c) / (7 * a * b)) +  ((4 * b) / (3 * a^^^2)) + ((3 * a) / (7 * b^^^2))";
val e213b = the (rewrite_set thy' false "common_nominator_p" e213b');

print("\n\nexample 214:\n");
print("a)\n");
val e214a'="((3 * x + 2 * y + 2 * z) / (4)) + ((-5 * x + -3 * y) / (3)) + ((x + y + -2 * z) / (2))";
val e214a = the (rewrite_set thy' false "common_nominator_p" e214a'); 
print("b)\n");
val e214b'="((5 * x + 2 * y + z) / (2)) + ((-7 * x + -3 * y) / (3)) + ((3 * x + 6 * y + -1 * z) / (12))";
val e214b = the (rewrite_set thy' false "common_nominator_p" e214b');

print("\n\nexample 216:\n");
print("a)\n"); 
val e216a'="((2 * b + 3 * c) / (a * c)) + ((3 * a + b) / (a * b)) + ((-2 * b^^^2 + -3 * a * c) / (a * b * c))";
val e216a = the (rewrite_set thy' false "common_nominator_p" e216a');  
print("b)\n");
val e216b'="((2 * a + 3 * b) / (b * c)) + ((3 * c + a) / (a * c)) + ((-2 * a^^^2 + -3 * b * c) / (a * b * c))";
val e216b = the (rewrite_set thy' false "common_nominator_p" e216b');

print("\n\nexample 217:\n");
val e217'="((z + -1) / (z)) + ((3 * z ^^^2 + -6 * z + 5) / (z^^^2)) + ((-4 * z^^^3 + 7 * z^^^2 + -5 * z + 5) / (z^^^3))";
val e217 = the (rewrite_set thy' false "common_nominator_p" e217'); 


val rls' = "common_nominator";
print("\n\nexample 218:\n"); 
val e218'="((9 * a^^^3 - 5 * a^^^2 + 2 * a + 8) / (108 * a^^^4)) + ((-5 * a + 3 * a^^^2 + 4) / (8 * a^^^3)) + ((-261 * a^^^3 + 19 * a^^^2 + -112 * a + 16) / (216 * a^^^4))";
val e218 = the (rewrite_set thy' false "common_nominator" e218'); 

print("\n\nexample 219:\n");
print("a)\n");
val e219a'="((1) / (y + 1)) + ((1) / (y + 2)) + ((1) / (y + 3))";
val e219a = the (rewrite_set thy' false "common_nominator" e219a');
print("b)\n");
val e219b'="((1) / (x + 1)) + ((1) / (x + 2)) + ((-2) / (x + 3))";
val e219b = the (rewrite_set thy' false "common_nominator" e219b'); 

print("\n\nexample 220:\n");
print("a)\n");
val e220a'="((17) / (5 * r + -2)) + ((-13) / (2 * r + 3)) + ((4) / (3 * r + -5))";
val e220a = the (rewrite_set thy' false "common_nominator" e220a');
print("b)\n");
val e220b'="((20 * a) / (a + -3)) + ((-19 * a) / (a + -4)) + ((a) / (a + -5))";
val e220b = the (rewrite_set thy' false "common_nominator" e220b'); 

print("\n\nexample 221:\n");
print("a)\n");
val e221a'="((a + b) / (a + -1 * b)) + ((a + -1 * b) / (a + b))";
val e221a = the (rewrite_set thy' false "common_nominator" e221a');
print("b)\n");
val e221b'="((x + -1 * y) / (x + y)) + ((x + y) / (x + -1 * y)) ";
val e221b = the (rewrite_set thy' false "common_nominator" e221b');

print("\n\nexample 222:\n");
print("a)\n");
val e222a'="((1 + -1 * x) / (1 + x)) + ((-1 + -1 * x) / (1 + -1 * x)) + ((4 * x) / (1 + -1 * x^^^2))";
val e222a = the (rewrite_set thy' false "common_nominator" e222a');
print("b)\n");
val e222b'="((1 + x ) / (1 + -1 * x)) + ((-1 + x) / (1 + x)) + ((2 * x) / (1 + -1 * x^^^2))";
val e222b = the (rewrite_set thy' false "common_nominator" e222b'); 

print("\n\nexample 225:\n");
print("a)\n");
val e225a'="((6 * a) / (a^^^2 + -64)) + ((a + 2) / (2 * a + 16)) + ((-1) / (2))";
val e225a = the (rewrite_set thy' false "common_nominator" e225a');
print("b)\n");
val e225b'="((a + 2 ) / (2 * a + 12)) + ((4 * a) / (a^^^2 + -36)) + ((-1) / (2))";
val e225b = the (rewrite_set thy' false "common_nominator" e225b'); 

print("\n\nexample 226:\n");
print("a)\n");
val e226a'="((35 * z) / (49 * z^^^2 + -4)) + -1 + ((14 * z + -1) / (14 * z + 4)) ";
val e226a = the (rewrite_set thy' false "common_nominator" e226a');
print("b)\n"); 
val e226b'="((45 * a * b) / (25 * a^^^2 + -9 * b^^^2)) + ((20 * a + 3 * b) / (10 * a + 6 * b))  + -2";
val e226b = the (rewrite_set thy' false "common_nominator" e226b');  

print("\n\nexample 227:\n");
print("a)\n");
val e227a'="((6 * z + 11) / (6 * z + 14)) + ((9 * z ) / (9 * z^^^2 + -49)) + -1 ";
val e227a = the (rewrite_set thy' false "common_nominator" e227a');
print("b)\n");
val e227b'="((16 * a + 37 * b) / (4 * a + 10 * b)) + ((6 * a * b) / (4 * a^^^2 + -25 * b^^^2)) + -4 ";
val e227b = the (rewrite_set thy' false "common_nominator" e227b'); 

print("\n\nexample 228:\n");
print("a)\n");
val e228a'="((7 * a + 11) / (3 * a^^^2 + -3)) + ((-2 * a + -1) / (a^^^2 + -1 * a)) + ((-1) / (3 * a + 3))";
val e228a = the (rewrite_set thy' false "common_nominator" e228a'); 
print("b)\n");
val e228b'="((11 * z + 2 * b) / (4 * b * z + -8 * b^^^2)) + ((-8 * z) / (z^^^2 + -4 * b^^^2)) + ((-9 * z + -2 * b) / (4 * b * z + 8 * b^^^2))";
val e228b = the (rewrite_set thy' false "common_nominator" e228b');  


print("\n\nexample 229:\n");
print("a)\n");
val e229a'="((5 * x^^^2 + y) / (x + 2 * y)) + ((-8 * x^^^3 + 4 * x^^^2 * y + 3 * x * y) / (x^^^2 + -4 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (x + -2 * y))";
val e229a = the (rewrite_set thy' false "common_nominator" e229a'); 
print("b)\n");
val e229b'="((7 * x^^^2 + y) / (x + 3 * y)) + ((-24 * x^^^2 * y + 5 * x * y + 21 * y^^^2) / (x^^^2 + -9 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (x + -3 * y))"; 
val e229b = the (rewrite_set thy' false "common_nominator" e229b'); 
 
print("\n\nexample 230:\n");
print("a)\n"); 
val e230a'="((5 * x^^^2 + y) / (2 * x + y)) + ((-16 * x^^^3 + 2 * x^^^2 * y + 6 * x * y) / (4 * x^^^2 + -1 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (2 * x + -1 * y))";
val e230a = the (rewrite_set thy' false "common_nominator" e230a');
print("b)\n");
val e230b'="((7 * x^^^2 + y) / (3 * x + y)) + ((-3 * x^^^3  + 15 * x * y + -7 * x^^^2 * y + 7 * y^^^2) / (9 * x^^^2 + -1 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (3 * x + -1 * y))";
val e230b = the (rewrite_set thy' false "common_nominator" e230b');

print("\n\nexample 231:\n");
print("a)\n");
val e231a'="((2 * x + 5 * y) / (x)) + ((2 * x^^^3 + -5 * y^^^3 + 3 * x * y^^^2) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -6 * y) / (x + -1 * y))";
val e231a = the (rewrite_set thy' false "common_nominator" e231a'); 
print("b)\n");
val e231b'="((6 * x + 2 * y) / (x)) + ((6 * x^^^2 * y + -4 * x * y^^^2 + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -3 * y) / (x + -1 * y))";
val e231b = the (rewrite_set thy' false "common_nominator" e231b');

print("\n\nexample 232:\n");
print("a)\n");
val e232a'="((2 * x + 3 * y) / (x)) + ((4 * x^^^3 + -1 * x * y^^^2 + -3 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -6 * y) / (x + -1 * y))";
val e232a = the (rewrite_set thy' false "common_nominator" e232a'); 
print("b)\n");
val e232b'="((5 * x + 2 * y) / (x)) + ((2 * x^^^3 + -3 * x * y^^^2 + 3 * x^^^2 * y + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-6 * x + -3 * y) / (x + -1 * y))";
val e232b = the (rewrite_set thy' false "common_nominator" e232b');

print("\n\nexample 233:\n");
print("a)\n");
val e233a'="((5 * x + 6 * y) / (x)) + ((5 * x * y^^^2 + -6 * y^^^3 + -2 * x^^^3 + 3 * x^^^2 * y) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-2 * x + -3 * y) / (x + -1 * y))";
val e233a = the (rewrite_set thy' false "common_nominator" e233a'); 
print("b)\n");
val e233b'="((6 * x + 5 * y) / (x)) + ((4 * x^^^2 * y + 3 * x * y^^^2 + -5 * y^^^3 + -2 * x^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -2 * y) / (x + -1 * y))";
val e233b = the (rewrite_set thy' false "common_nominator" e233b');

print("\n\nexample 234:\n");
print("a)\n");
val e234a'="((5 * a + b) / (2 * a * b + -2 * b^^^2)) + ((-3 * a + -1 * b) / (2 * a * b + 2 * b^^^2)) + ((-2 * a) / (a^^^2 + -1 * b^^^2))";
val e234a = the (rewrite_set thy' false "common_nominator" e234a'); 
print("b)\n"); 
val e234b'="((5 * a + 3 * b) / (6 * a * b + -18 * b^^^2)) + ((-3 * a + -3 * b) / (6 * a * b + 18 * b^^^2)) + ((-2 * a) / (a^^^2 + -9 * b^^^2)) ";
val e234b = the (rewrite_set thy' false "common_nominator" e234b');  

print("\n\nexample 235:\n");
print("a)\n");
val e235a'="((10 * x + 3 * y) / (12 * x * y + -18 * y^^^2)) + ((-6 * x + -3 * y) / (12 * x * y + 18 * y^^^2)) + ((-4 * x) / (4 * x^^^2 + -9 * y^^^2))";
val e235a = the (rewrite_set thy' false "common_nominator" e235a'); 
print("b)\n"); 
val e235b'="((8 * a + b) / (4 * a * b + -2 * b^^^2)) + ((-4 * a + -1 * b) / (4 * a * b + 2 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -1 * b^^^2)) ";
val e235b = the (rewrite_set thy' false "common_nominator" e235b');  
 
print("\n\nexample 236:\n");
print("a)\n"); 
val e236a'="((8 * a + 5 * b) / (20 * a * b + -50 * b^^^2)) + ((-4 * a + -5 * b) / (20 * a * b + 50 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -25 * b^^^2))";
val e236a = the (rewrite_set thy' false "common_nominator" e236a');  
print("b)\n");   
val e236b'="((24 * x + y) / (6 * x * y + -2 * y^^^2)) + ((-18 * x + -1 * y) / (6 * x * y + 2 * y^^^2)) + ((-15 * x) / (9 * x^^^2 + -1 * y^^^2)) ";
val e236b = the (rewrite_set thy' false "common_nominator" e236b');  


val rls' = "cancel";
print("\n\nexample heuberger:\n");
val eheu'="(x^^^4 + x * y + x^^^3 * y + y^^^2) / (x + 5 * x^^^2 + y + 5 * x * y + x^^^2 * y^^^3 + x * y^^^4)";
val eheu = the (rewrite_set thy' false "cancel" eheu');

val rls' = "common_nominator_p";
print("\n\nexample stiefel:\n");
val est1'="(7) / (-14) + (-2) / (4)";
val est1 = the (rewrite_set thy' false "common_nominator_p" est1');
if est1 = ("-1 / 1",[]) then ()
else raise error "new behaviour in rationals.sml: est1'";
    
val t = (term_of o the o (parse thy))
"(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
val Some (t',_) = factout_ thy t;
term2str t';
"(3 + x) * (3 - x) / ((3 - x) * (3 - x))";
    
    
(*WN.28.8.02: tests for the 'reverse-rewrite' functions:
  these are defined in Rationals.ML and stored in 
  the 'reverse-ruleset' cancel*)

(*the term for which reverse rewriting is demonstrated*)
  val t = (term_of o the o (parse thy))
	      "(9 - x ^^^ 2) / (9 + 6 * x + x ^^^ 2)";
  val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
  		       next_rule=nex,normal_form=nor,...},...} = cancel;

(*normal_form produces the result in ONE step*)
  val Some (t',_) = nor t;
  term2str t';

(*initialize the interpreter state used by the 'me'*)
  val (t,_,revsets,_) = ini t;

(*find the rule 'r' to apply to term 't'*)
  val Some r = nex revsets t;
  (*val r = Thm ("sym_#mult_2_3","6 = 2 * 3") : rule*)

(*check, if the rule 'r' applied by the user to 't' belongs to the ruleset;
  if the rule is OK, the term resulting from applying the rule is returned,too;
  there might be several rule applications inbetween,
  which are listed after the thead in reverse order*)
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(9 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find the next rule to apply*)
  val Some r = nex revsets t;
  (*val r = Thm ("sym_#power_3_2","9 = 3 ^^^ 2") : rule*)

(*check the next rule*)
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find and check the next rules, rewrite*)
  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 - x) * (3 + x) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 - x) * (3 + x) / ((3 + x) * (3 + x))";

  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  val ss = term2str t;
  if ss = "(3 - x) / (3 + x)" then ()
  else raise error "rational.sml: new behav. in rev-set cancel";
  terms2str asm; 



(*WN.11.9.02: the 'reverse-ruleset' cancel_p*)

  (*the term for which reverse rewriting is demonstrated*)
  val t = (term_of o the o (parse thy))
	      "(9 + (-1)*x^^^2) / (9 + ((-6)*x + x^^^2))";
  val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
  		       next_rule=nex,normal_form=nor,...},...} = cancel_p;
  (*normal_form produces the result in ONE step*)
  val Some (t',_) = nor t;
  term2str t';
  (*initialize the interpreter state used by the 'me'*)
(* WN.14.3.03: rewrite__ Thm | Calc | missing: Rls_  FIXXXXME --------
  val (t,_,revsets,_) = ini t;
---------------------------------------------------------------------*)

(*
 val [rs] = revsets;
 filter_out (eq_Thms ["sym_real_add_zero_left",
		      "sym_real_mult_0",
		      "sym_real_mult_1"]) rs;

 10.10.02: dieser Fall terminiert nicht (make_poly enth"alt zu viele rules)
  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;

  val Some r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;

 ------ revset ----------------------------------------------------
/// [Thm ("sym_real_add_zero_left","?z = 0 + ?z"),
///  Thm ("sym_real_mult_0","0 = 0 * ?z"),
!    Thm ("sym_#mult_2_(-3)","(-6) * x = 2 * ((-3) * x)"),
!    Thm ("sym_#add_(-3)_3","0 = (-3) + 3"),
 
?    Thm ("sym_real_num_collect_assoc",
       "[| ?l is_const; ?m is_const |]
  	==> (?l + ?m) * ?n + ?k = ?l * ?n + (?m * ?n + ?k)"),
OK   Thm ("sym_real_mult_2_assoc","2 * ?z1.0 + ?k = ?z1.0 + (?z1.0 + ?k)"),
OK   Thm ("sym_real_add_left_commute","?y + (?x + ?z) = ?x + (?y + ?z)"),
///  Thm ("sym_real_mult_1","?z = 1 * ?z"),
!    Thm ("sym_#power_3_2","9 = 3 ^^^ 2"),
!    Thm ("sym_#mult_-1_-1","1 * x ^^^ 2 = -1 * (-1 * x ^^^ 2)"),
!    Thm ("sym_#mult_-1_3","(-3) * x = -1 * (3 * x)"),
OK   Thm ("realpow_twoI","?r1 ^^^ 2 = ?r1 * ?r1"  [.]),
OK   Thm ("sym_real_add_assoc",
      "?z1.0 + (?z2.0 + ?z3.0) = ?z1.0 + ?z2.0 + ?z3.0"),
OK   Thm
     ("sym_real_mult_assoc","?z1.0 * (?z2.0 * ?z3.0) = ?z1.0 * ?z2.0 * ?z3.0"),
OK   Thm ("sym_real_mult_left_commute",
      "?z2.0 * (?z1.0 * ?z3.0) = ?z1.0 * (?z2.0 * ?z3.0)"),
OK   Thm ("sym_real_mult_commute","?w * ?z = ?z * ?w"),
?    Thm ("sym_real_add_mult_distrib2",
      "?w * ?z1.0 + ?w * ?z2.0 = ?w * (?z1.0 + ?z2.0)"),
?    Thm ("sym_real_add_mult_distrib",
      "?z1.0 * ?w + ?z2.0 * ?w = (?z1.0 + ?z2.0) * ?w"),
OK   Thm ("real_mult_div_cancel2","?k ~= 0 ==> ?m * ?k / (?n * ?k) = ?m / ?n")]
 -------- revset ---------------------------------------------------- 

  val t = (term_of o the o (parse thy)) "(-6) * x";
  val t = (term_of o the o (parse thy)) 
	      "(9 + (-1)*x^^^2) / (9 + ((-6)*x + x^^^2))";
  val thm = (mk_thm thy "(-6) * x = 2 * ((-3) * x)") 
      handle e => print_exn e;
  val Some (t',_) = rewrite_ thy e_rew_ord e_rls false thm t;     
  term2str t';
----------------------------------------------------------------------*)

print "\n\n\n******************  all tests successfull  *************************\n";



(*WN.17.3.03 =========================================================vvv---*)
val t = str2term "(3*x+5)/18 - x/2  - -(3*x - 2)/9 = 0";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "1 / 18 = 0" then () else raise error "rational.sml 1";

val t = str2term "(17*x - 51)/9 - (-(13*x - 3)/6) + 11 - (9*x - 7)/4 = 0";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(237 + 65 * x) / 36 = 0" then () 
else raise error "rational.sml 2";

val t = str2term "(1/2 + (5*x)/2)^^^2 - ((13*x)/2 - 5/2)^^^2 - (6*x)^^^2 + 29";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(23 + (35 * x + -72 * x ^^^ 2)) / 1" then () 
else raise error "rational.sml 3";
trace_rewrite:=true;
val t = str2term "Not (6*x is_atom)";
val Some (t',_) = rewrite_set_ thy false powers_erls t; term2str t';
"True";
val t = str2term "1 < 2";
val Some (t',_) = rewrite_set_ thy false powers_erls t; term2str t';
"True";
val t = str2term "(6*x)^^^2";
val Some (t',_) = rewrite_ thy dummy_ord powers_erls false 
			   (num_str realpow_def_atom) t;
term2str t';
trace_rewrite:=false;

val t = str2term "-1 * (-2 * (5 / 2 * (13 * x / 2)))";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "130 * x / 4" then () else raise error "rational.sml 4";

val t = str2term "1 - ((13*x)/2 - 5/2)^^^2";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-21 + (130 * x + -169 * x ^^^ 2)) / 4" then () 
else raise error "rational.sml 5";

(*Schalk I, p.92 Nr. 609a*)
val t = str2term "2*(3 - x/5)/3 - 4*(1 - x/3) - x/3 - 2*(x/2 - 1/4)/27 +5/54";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-255 + 112 * x) / 135" then () 
else raise error "rational.sml 6";

(*Schalk I, p.92 Nr. 610c*)
val t = str2term "((x- 1)/(x+1) + 1) / ((x- 1)/(x+1) - (x+1)/(x- 1)) - 2";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-3 + -1 * x) / 2" then () else raise error "rational.sml 7";

(*Schalk I, p.92 Nr. 476a*)
val t = str2term "(x^^^2/(1 - x^^^2) + 1)/(x/(1 - x) + 1) *\
		 \ (1 + x)";(*. a/b : c/d translated to a/b * d/c .*)
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "1 / 1" then () else raise error "rational.sml 8";

(*............................vvv---TODO: sollte gehen mit poly_order *)
(*Schalk I, p.92 Nr. 472a*)
val t = str2term "((8*x^^^2 - 32*y^^^2)/(2*x + 4*y))/\
		 \((4*x - 8*y)/(x + y))";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
"(-32 * y ^^^ 3 +\n (8 * x ^^^ 3 + (-32 * (x * y ^^^ 2) + 8 * (y * x ^^^ 2)))) /\n(-32 * y ^^^ 2 + 8 * x ^^^ 2)";
(*###########################statt "x + y" poly_order notwendig!*) 

(*Schalk I, p.70 Nr. 480b; a/b : c/d translated to a/b * d/c*)
val t = str2term "((12*x*y/(9*x^^^2 - y^^^2))/\
		 \(1/(3*x - y)^^^2 - 1/(3*x + y)^^^2)) *\
		 \(1/(x - 5*y)^^^2 - 1/(x + 5*y)^^^2)/\
		 \(20*x*y/(x^^^2 - 25*y^^^2))";
(*... nicht simpl, zerlegt ...*)
val t = str2term "((12*x*y/(9*x^^^2 - y^^^2))/\
		 \(1/(3*x - y)^^^2 - 1/(3*x + y)^^^2))";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
"(-12 * (x * y ^^^ 3) + 108 * (x * (y * x ^^^ 2))) / (12 * (x * y))";
(*                             ~~~~~~~~~~ poly_order notwendig!*)
val t = str2term "(1/(x - 5*y)^^^2 - 1/(x + 5*y)^^^2)/\
		 \(20*x*y/(x^^^2 - 25*y^^^2))";
val Some (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
"(-500 * (x * y ^^^ 3) /\n (x ^^^ 4 + (625 * y ^^^ 4 + -50 * (x ^^^ 2 * y ^^^ 2))) +\n 20 * (x * (y * x ^^^ 2)) /\n (x ^^^ 4 + (625 * y ^^^ 4 + -50 * (x ^^^ 2 * y ^^^ 2)))) /\n(20 * (x * y))";
trace_rewrite:=true;
trace_rewrite:=false;

(*WN.17.3.03 =========================================================^^^---*)
